<?php
/*
Plugin Name: BanIP
Version: auto
Description: Ban adresse IP or range adresse IP.
Plugin URI: http://piwigo.org/ext/extension_view.php?eid=824
Author: ddtddt
Author URI: http://temmii.com/piwigo/
Has Settings: webmaster
*/

// +-----------------------------------------------------------------------+
// | Ban IP plugin for Piwigo by TEMMII                                    |
// +-----------------------------------------------------------------------+
// | Copyright(C) 2016-2023 ddtddt               http://temmii.com/piwigo/ |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

global $prefixeTable;

// +-----------------------------------------------------------------------+
// | Define plugin constants                                               |
// +-----------------------------------------------------------------------+

define('BANIP_ID', basename(dirname(__FILE__)));
define('BANIP_PATH', PHPWG_PLUGINS_PATH.BANIP_ID.'/');
define('BANIP_TABLE' , $prefixeTable . 'ip_ban');
define('BANIP_ADMIN',get_root_url().'admin.php?page=plugin-'.BANIP_ID);

add_event_handler('loc_end_section_init', 'banip');

function banip()
{
  global $user, $page;
   load_language('plugin.lang', BANIP_PATH);
  if (is_admin() ) return;
  
  $Vip = $_SERVER["REMOTE_ADDR"];
  if (isset($Vip)){
    $plage= explode(".", $Vip);
    $Vip2=$plage[0].".".$plage[1].".".$plage[2].".*";
    $Vip3=$plage[0].".".$plage[1].".*.*";
  }

  $query = 'SELECT ip FROM ' . BANIP_TABLE . ' WHERE ip="' . $Vip . '";'; 
  $result = pwg_query($query);

  while(list($ip) = pwg_db_fetch_row($result))
  {

    die("IP " . $ip . "  ".l10n('IP ban'));
  }

  $query = 'SELECT ip FROM ' . BANIP_TABLE . ' WHERE ip="' . $Vip2 . '";';
  $result = pwg_query($query);

  while(list($ip) = pwg_db_fetch_row($result))
  {
    die("IP " . $ip . "  ".l10n('Range IP address banned'));
  }

  $query = 'SELECT ip FROM ' . BANIP_TABLE . ' WHERE ip="' . $Vip3 . '";';
  $result = pwg_query($query);
  
  while(list($ip) = pwg_db_fetch_row($result))
  {
    die("IP " . $ip . "  ".l10n('Range IP address banned'));
  }

  
}

// Plugin for admin
if (script_basename() == 'admin') {
    include_once(dirname(__FILE__) . '/initadmin.php');
}
